#ifndef BK_EDIT_SORT_H
#define BK_EDIT_SORT_H

enum order
{
	UNSORTED = 0,
	ALPHABETICALLY,
	ALPHABETICALLY_FOLDER_FIRST,
	ALPHABETICALLY_REVERSE,
	ALPHABETICALLY_REVERSE_FOLDER_FIRST
};

enum
{
	GET_SORT_ORDER = -1,
	SET_SORT_ORDER = -2
};

typedef struct order_string_tag
{
	int order;
	char *string;
	GtkCListCompareFunc cmp;
} order_string;


void bk_edit_sort (gpointer null, int order, GtkWidget *widget);
void bk_edit_sort_sort (int order, void (*sort) (GtkCTree *ctree, GtkCTreeNode *node), GtkCTreeNode *top);

void bk_edit_sort_reset_to_menu_value (void);
void bk_edit_sort_menu_update (char *order);
int bk_edit_sort_menu_get_menu_state (void);
int bk_edit_sort_menu_state_is_unsorted (void);
void bk_edit_sort_menu_set_sort_order (gpointer null, int o, GtkWidget *widget);

int bk_edit_sort_get_highest_order (GtkCTreeNode *folder, GtkCTreeNode *exclude_this_node_from_process);
void bk_edit_sort_reorder_folder (GtkCTreeNode *folder, GtkCTreeNode *exclude_this_node_from_reorder);

#endif
